/*

	NCC version 1.0
	Copyright (c)1994 Clifford Hammerschmidt
	This source code is distributed as is.
	You are free to modify this source code as you see fit.

	I take no responsiblity for anything this program does, intended or not.

*/
#undef __UNIX__

/* Uncomment this following block to compile on Unix Systems */

#define __UNIX__
#undef __BORLANDC__

#include <stdio.h>

#ifdef __UNIX__
#include <strings.h>
#endif

#ifdef __BORLANDC__
#include <string.h>
#endif

typedef struct {
	char name[40];
	char attach[40];
	int  start;
	int  end;
	} page ;

#ifdef __BORLANDC__
int trim(char *src,char *dest);
int getname(char *src,char *dest);
int getattach(char *src,char *dest);
#endif

int main()
{
#ifdef  __BORLANDC__
	page *pages;
	char **data;
#endif

#ifdef __UNIX__
	page pages[100];
	char data[250][40];
#endif

	char ifilename[128];
	char ofilename[128];
	char buff[256],buff1[256];
#ifdef __BORLANDC__
	char far *tmp;
#endif

	int i,cur,pnum,intext,done,lines,idxp;
	FILE *in,*out;

#ifdef __BORLANDC__
	pages = new page[100];
	data = new char*[250];


	for(i=0;i<250;i++) data[i] = new char[100];
#endif

    printf("NCC version 1.0\n\rHP Note Compiler (c)1994 Clifford Hammerschmidt\n\r\n\r\tPlease send any comments, suggestions, problems\n\r\tand beer to chammers@engr.uvic.ca\n\r\n\r\tThis program is beerware.  Please send anything\n\r\tPostcards, Money, Beer, First Born Children, etc\n\r\n\r\tTO:\tClifford Hammerschmidt\n\r\t\t4080 Torquay Dr.\n\r\t\tVictoria, B.C., Canada\n\r\t\tV8N 3K7\n\r\n\r");

	printf("Input File:");
	scanf("%s",ifilename);

	strcpy(ofilename,ifilename);
#ifdef __BORLANDC__
	tmp=_fstrstr(ofilename,".");
	if (tmp!=NULL) *tmp=NULL;
#endif
	strcat(ofilename,".vit");
	if((in=fopen(ifilename,"rt"))==NULL)
	{
		printf("Can't open input file'%s'\n\r",ifilename);
		return 2;
	}

	if((out=fopen(ofilename,"wt"))==NULL)
	{
		printf("Can't open output file'%s'\n\r",ofilename);
		fclose(in);
		return 3;
	}
	printf("Processing\n\r");
	cur=0;
	intext=0;
	done=0;
	pnum=0;
	while (done==0)
	{
		fgets(buff,255,in);
		trim(buff,buff1);
		switch (buff1[0])
		{
			case '#':
			{
				done=1;
				break;
			}
			case '{':
			{
				intext=1;
				break;
			}
			case '}':
			{
				intext=0;
				pages[pnum].end=cur;
				pnum++;
				break;
			}
			case ';':
			{
                /* Comment lines */
			}
			default:
			{
				if (intext==0)
				{
					if (strcmp(buff1,"")!=0)
					{
						getname(buff1,pages[pnum].name);
						getattach(buff1,pages[pnum].attach);
						pages[pnum].start=cur+1;
						strcpy(data[cur],"[");
						strcat(data[cur],pages[pnum].name);
						strcat(data[cur],"]");
						cur++;
						lines=0;
					}
				}
				else
				{
                    lines++;
                    if (lines>9)
					{
						pages[pnum].end=cur;
						pnum++;
						pages[pnum].start=cur+1;
						strcpy(pages[pnum].name,pages[pnum-1].name);
						strcpy(pages[pnum].attach,pages[pnum-1].attach);
						strcpy(data[cur],"[");
						strcat(data[cur],pages[pnum].name);
						strcat(data[cur],"]");
						cur++;
                        lines=1;
					}
                    strcpy(data[cur],buff1);
                    cur++;
                 }
			}
		}
		printf(".");
	}
	printf("\n\r");
    printf("pages:%d\n\r",pnum);
    printf("data lines:%d\n\r\n\r",cur);


    fprintf(out,"%%%%HP: T(3)A(D)F(.);\n\\<< { \n{ \n");
    idxp=(pnum-1)/10+1;
	for(i=0;i<idxp-1;i++)
	{
        fprintf(out,"{ %d %d %s } \n",i*10+1,(i+1)*10,"\\<< DROP \\>>");
	}
    fprintf(out,"{ %d %d %s } \n",idxp*10-9,pnum,"\\<< DROP \\>>");

	for(i=0;i<pnum;i++)
	{
        fprintf(out,"{ %d %d %s } \n",pages[i].start+pnum,pages[i].end+pnum,pages[i].attach);
	}

    fprintf(out,"} \n");

	for(i=0;i<pnum;i++)
	{
        fprintf(out,"\"%02d %s\" \n",i+idxp+1,pages[i].name);
	}

	for(i=0;i<cur;i++)
	{
        fprintf(out,"\"%s\" \n",data[i]);
	}

    fprintf(out,"} \n");
    fprintf(out," VIEWIT \\>>\n");

	fclose(in);
	fclose(out);
	return 0;
}


int trim(src,dest)
char *src,*dest;
{
	while (*src==' '||*src=='\t')
	{
		src++;
	}
	while (!(*src=='\n'||*src=='\r'))
	{
		*dest=*src;
		dest++;
		src++;
	}
	*dest=NULL;

	return 0;
}

int getname(src,dest)
char *src,*dest;
{
	while (*src!='(')
	{
		*dest=*src;
		dest++;
		src++;
	}
	*dest=NULL;
	return 0;
}

int getattach(src,dest)
char *src,*dest;
{
	char *tmp;

	tmp=dest;
	while(*src!='(')
	{
		src++;
	}

	src++;
 
	while (!(*src==')' || *src==',' || *src=='('))
	{
		*dest=*src;
		dest++;
		src++;
	}
 
	*dest=NULL;
	if (strcmp(tmp,"")==0) strcpy(tmp,"\\<< DROP \\>>");
	return 0;
}
