**********************
* GLOBAL name abbr.
*
* an: animation (anNEWL)
* bn: banners (bnCLR)
* cg: CHECK GUESS (cgSTRT)
* ch: chHIGH
* ga: gaSTRT
* in: inSTOP, inKEYS
* is: isINIT SCREEN
* ky: kyTOGG, kyGUES
* le: leDRAW
* ma: maMAIN
* nu: nuDRAW
* pi: piPICK
* sc: scADD, scDISP
* se: seNOT, seCHK, BOGUS
* sh: shDRAW, shDPUZ
* sr: STORAGE/RETRIEVAL
* tb: tbIN1, tbIN2, tbTIME
*
* misc: BOGUS, AXORC, ASLBC,
*   ASRBC, BSLW5, BSRW5
*
* sounds: s1SND, s2SND,
*   s3SND, s4SND
*
**********************
* sr SYSTEM uses
*
* 0: ABUFF bitmap addr
* 1: LEVEL
* 2: GUESS #
* 3: PUZZLE
* 4: MAX GUESSES THIS LEVEL
* 5: dec on L6
* 6: kyCURSOR
* 7: scratch - cg,in,ch
* 8: scratch - cg,ch
* 9: times to play level
* 10: score (most significant)
* 11: score (least significant)
* 12: POT
* 13: POT decr.
* 14: starting POT
* 15: CLOCK time
* 16: 10 sec decr.
* 17: addr of high scores
* 18: letter pos
* 19: Total guesses you make
* 20: Total time to play
* 21: Addr of seCHK
**********************
*
* R0: sr pointer
* R1: scratch
* R2: scratch
* R3: puzzle
* R4: guess
*
**********************
*
* STATUS FLAGS:
*
* 0: YOU WIN flag
* 1: max decr flg, lvl 5&6
* 2: leDRAW
* 3: chSECRET
* 4: level 6 SND
* 5: maOUT
* 6:
* 7:
* 8:
* 9:
* 10:
* 11: sound on/off
*
**********************


CRC    EQU     #00104

       GOSBVL  =SAVPTR

* The stack:
* L4: ABUFF
* L3: High Scores
* L2: String with at least (20 * 5) nibbles
* L1: (TRUE/FALSE) sound flag

       P=      0
       INTOFF
       ST=0    15

       D0=(5)  (=ANNCTRL)+1
       C=DAT0  1
       CBIT=0  0
       DAT0=C  1

       A=DAT1  A
       LCHEX   03AC0  * FALSE
       ?A=C    A
       GOYES   maSON
       ST=1    11     * Sound off
       GOTO    maL2
maSON  ST=0    11     * Sound on


maL2   D1=D1+  5
       A=DAT1  A      * DATA string
       A=A+CON A,10
       R0=A.F  A      * Save this addr here forever

       D1=D1+  5
       C=DAT1  A      * high scores
       C=C+CON A,10
       GOSUBL  srS17
       
       D1=D1+  5
       A=DAT1  A      * ABUFF
       LCHEX   00014  * offset past prolog, etc.
       C=C+A   A
       GOSUBL  srS0   * bitmap addr

**********************
* Beginning inits    *
**********************

       GOSUBL  isINIT

*****
* executed at game start
*****

       C=0     A
       GOSUBL  srS10
       GOSUBL  srS11
       GOSUBL  srS19
       GOSUBL  srS20
       LCHEX   1
       GOSUBL  srS1   * Level 2
       GOSUBL  srS9
       LCHEX   A      * max guesses
       GOSUBL  srS4
       LCHEX   100
       GOSUBL  srS13
       LCHEX   2000
       GOSUBL  srS14
       LCHEX   00005  * (5)*2 each rnd
       GOSUBL  srS5   * for L6 only

*****
* executed at level start
*****

gaSTRT ST=0    0      * set YOU WIN to FALSE
       ST=0    4
       C=0     A
       GOSUBL  srS2   * Guess num
       GOSUBL  srR14
       GOSUBL  srS12
       GOSUBL  scDPOT
       GOSUBL  scDISP
       GOSUBL  piPICK * Pick a puzzle
       GOSUBL  bnCLR
       GOSUBL  kyM0
       GOSUBL  tbIN1
       GOSUBL  kyGUES * Play 1 round

* When you get here,
* a round has just
* finished.  ST0
* determins win/loss.

       GOSUBL  shDPUZ * show the puzzle
       ?ST=1   0      * Did you win?
       GOYES   maSCOR
maOVER GOSUBL  s2SND
       GOTO    maPKEY

maSCOR GOSUBL  scADD
       GOSUBL  s1SND

maPKEY GOSUBL  bnPKEY

maSTP1 LCHEX   1FF
       OUT=C
       GOSBVL  =CINRTN
       LAHEX   0003F
       A=A&C   A
       ?A#0    A
       GOYES   maSTP1

maWKEY LCHEX   1FF
       OUT=C
       GOSBVL  =CINRTN
       LAHEX   0003F
       A=A&C   A
       ?A=0    A
       GOYES   maWKEY

       ?ST=1   0      * you won?
       GOYES   maNEWL
       GOSUBL  chHIGH
       GOSUBL  srR21
       PC=C           * GOLONG seCHK

maNEWL GOSUBL  anNEWL
       GOTO    gaSTRT

maOUT  GOSUBL  srR0
       LAHEX   007CD
       C=C+A   A
       D0=C
       C=DAT0  1
       ?CBIT=1 0
       GOYES   maOSET
       ST=0    5
       GOTO    maOKEY
maOSET ST=1    5
maOKEY LCHEX   400
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 15
       GOYES   maOBSP
       GOSUBL  bnEXIT
       GOSUB   maYN

* if we return here,
* they pressed (Y)

maEND  GOSBVL  =GETPTR
       INTON
       ST=1    15
       A=DAT0  A
       D0=D0+  5
       PC=(A)

maOBSP LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 0
       RTNYES
       GOSUBL  bnQUIT
       GOSUB   maYN

* if we return here,
* they pressed (Y)

       ST=0    0
       GOLONG  maOVER

maYN   GOSUBL  tbTIME
       LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=1 3
       RTNYES

       LCHEX   040
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 4
       GOYES   maYN
       C=RSTK
       GOSUBL  bnCLR
       GOSUBL  kyM0
       ?ST=0   5
       RTNYES
       GOLONG  kyM1


kyGUES C=0     W
       R4=C           * Guess
       LAHEX   00018
       GOSUBL  srR2
kySUB  A=A-CON A,2
       C=C-1   A
       GONC    kySUB
       C=A     A
       GOSUBL  srS6   * cursor

       GOSUBL  kyPUTC * show cursor
kySTOP GOSUBL  tbTIME
       LCHEX   1FF
       OUT=C
       GOSBVL  =CINRTN
       LAHEX   0003F
       A=A&C   A
       ?A#0    A
       GOYES   kySTOP

kyKEYS GOSUBL  maOUT  * check [ON], [<-]
       GOSUBL  tbTIME
kyCE   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   kyCD
       A=0     A
       GOSUBL  kyGET
       GOTO    kySHP

kyCD   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 2
       GOYES   kyCC
       LAHEX   00001
       GOSUBL  kyGET
       GOTO    kySHP

kyCC   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 3
       GOYES   kyCB
       LAHEX   00002
       GOSUBL  kyGET
       GOTO    kySHP

kyCB   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 4
       GOYES   kyC1
       LAHEX   00003
       GOSUBL  kyGET
       GOTO    kySHP

kyC1   LCHEX   002
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 3
       GOYES   kyC2
       A=0     A
       GOTO    kySHP

kyC2   LCHEX   002
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 2
       GOYES   kyC3
       LAHEX   00001
       GOTO    kySHP

kyC3   LCHEX   002
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   kyC4
       LAHEX   00002
       GOTO    kySHP

kyC4   LCHEX   004
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 3
       GOYES   kyC5
       LAHEX   00003
       GOTO    kySHP

kyC5   LCHEX   004
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 2
       GOYES   kyC6
       LAHEX   00004
       GOTO    kySHP

kyC6   LCHEX   004
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   kyC7
       LAHEX   00005
       GOTO    kySHP

kyC7   LCHEX   008
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 3
       GOYES   kyC8
       LAHEX   00006
       GOTO    kySHP

kyC8   LCHEX   008
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 2
       GOYES   kyCF
       LAHEX   00007
       GOTO    kySHP

kyCF   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 0
       GOYES   kyCNXT
       LAHEX   00008
       GOTO    kySHP2

kySHP  R1=A.F  A
       LCHEX   000EE  * A is shape #
       B=C     A
       GOSUBL  srR6
kySHD1 C=C-B   A
       GOC     kySHNX
       ASL     W
       P=P+1
       GOTO    kySHD1
kySHNX C=R4
       C=A     P
       R4=C
       P=      0
       A=R1.F  A

kySHP2 GOSUBL  srR6
       C=C+1   A
       GOSUBL  shDRAW
       GOSUBL  kyADV
       GOSUBL  s4SND
       GOTO    kySTOP

kyCNXT LCHEX   080
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 0
       GOYES   kyCQ
       GOSUBL  kyTOGG
       GOTO    kySTOP

kyCQ   LCHEX   040
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   kyCK
       GOSUBL  kyADV
       GOTO    kySTOP

kyCK   LCHEX   080
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   kyCPM
       GOSUBL  kyBLC
       GOSUBL  srR6
       LAHEX   000EE
       C=C-A   A
       GONC    kyCKST

       B=C     A
       GOSUBL  srR1   * level
kyCKAD B=B+A   A
       C=C-1   A
       GONC    kyCKAD
       C=B     A

kyCKST GOSUBL  srS6
       GOSUBL  kyPUTC
       GOTO    kySTOP

kyCPM  LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 3
       GOYES   kyCENT
       ?ST=1   11
       GOYES   kyPMSS
       ST=1    11     * Sound off
       GOTO    kySTOP

kyPMSS ST=0    11     * Sound on
       LAHEX   00020  * length of blip
kySBLP LCHEX   800
       OUT=C
       LCHEX   00012  * Pitch 1
kySD1  C=C-1   A
       GONC    kySD1
       C=0     A
       OUT=C
       LCHEX   0000E  * Pitch 2
kySD2  C=C-1   A
       GONC    kySD2
       A=A-1   A
       GONC    kySBLP
       GOTO    kySTOP

kyCENT LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 4
       GOYES   kyNONE
       GOTO    cgSTRT

kyNONE GOTO    kyKEYS


kyPUTC GOSUBL  srR6   * Put on cursor
       B=C     A
       GOSUBL  srR0
       C=C+B   A
       D0=C
       LCHEX   00005
       B=C     A
       LCHEX   4      * cursor bit
kyPLIN A=DAT0  1
       A=A!C   A
       DAT0=A  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    kyPLIN
       RTN

kyBLC  GOSUBL  srR6
       B=C     A
       GOSUBL  srR0
       C=C+B   A
       D0=C
       LCHEX   00005
       B=C     A
       LCHEX   B      * inv cursor bit
kyBLIN A=DAT0  1
       A=A&C   A
       DAT0=A  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    kyBLIN
       RTN

kyADV  GOSUBL  kyBLC
       GOSUBL  srR6
       LAHEX   000EE
       C=C+A   A
       D=C     A
       GOSUBL  srR1   * level
       GOSBVL  =MUL#
       A=B     A
       LCHEX   00016
       C=C+A   A
       ?D>C    A
       GOYES   kyWRAP
       C=D     A
kyASTO GOSUBL  srS6
       GOTO    kyPUTC

kyWRAP LAHEX   00018
       GOSUBL  srR2
kyWSUB A=A-CON A,2
       C=C-1   A
       GONC    kyWSUB
       C=A     A
       GOTO    kyASTO

kyGET  R1=A.F  A
       GOSUBL  srR0
       LAHEX   007CD
       C=C+A   A
       D0=C
       A=R1.F  A
       C=DAT0  1
       ?CBIT=0 0
       RTNYES
       A=A+CON A,4
       RTN

kyTOGG GOSUBL  srR0
       LAHEX   007CD
       C=C+A   A
       D0=C
       C=DAT0  1
       ?CBIT=1 0      * M0==0, M1==1
       GOYES   kyM0
       GOTO    kyM1

kyM0   A=0     A
       LCHEX   007CD
       GOSUBL  shDRAW

       LAHEX   00001
       LCHEX   007C7
       GOSUBL  shDRAW

       LAHEX   00002
       LCHEX   007C1
       GOSUBL  shDRAW

       LAHEX   00003
       LCHEX   007BB
       GOTO    shDRAW * AUTO RTN

kyM1   LAHEX   00004
       LCHEX   007CD
       GOSUBL  shDRAW

       LAHEX   00005
       LCHEX   007C7
       GOSUBL  shDRAW

       LAHEX   00006
       LCHEX   007C1
       GOSUBL  shDRAW

       LAHEX   00007
       LCHEX   007BB
       GOTO    shDRAW * AUTO RTN

kyERR  GOSUB   kyERRS
       GOTO    kySTOP

kyERRS ?ST=1   11
       RTNYES
       LAHEX   00010  * length
kyEBLP LCHEX   800
       OUT=C
       LCHEX   00100  * P1
kyED1  C=C-1   A
       GONC    kyED1
       C=0     A
       OUT=C
       LCHEX   000D0  * P2
kyED2  C=C-1   A
       GONC    kyED2
       A=A-1   A
       GONC    kyEBLP
       RTN

cgSTRT GOSUBL  srR6
       LAHEX   000EE
cgSDEC C=C-A   A
       GONC    cgSDEC
       C=C+A   A
       C=C+1   A      * offset to first guessed block
       B=C     A
       GOSUBL  srR0
       B=B+C   A
       GOSUBL  srR1
       CBEX    A
cgSVER D0=C
       C=0     A
       C=DAT0  1
       ?C#0    A      * shape here?
       GOYES   cgVOK
       GOTO    kyERR  * no good
cgVOK  CD0EX
       C=C+A   A
       B=B-1   A
       GONC    cgSVER

       GOSUBL  srR19
       C=C+1   A
       GOSUBL  srS19  * total guesses so far
       GOSUBL  kyBLC
       LCHEX   FFFFFF
       R1=C
       GOSUBL  srR1
       P=C     0      * level
       B=0     A
       C=R4
       A=R3
cgBLK  ?C#A    P
       GOYES   cgBNXT
       B=B+1   A
       A=R1.F  P
       C=R1.F  P
       C=C-1   P
cgBNXT P=P-1
       GONC    cgBLK
       P=      0

       R1=A
       R2=C
       GOSUBL  srR6
       LAHEX   000EE
cgND1  C=C-A   A
       GONC    cgND1
       C=C+A   A
       LAHEX   005B7  * offset to num area
       C=C+A   A
       D=C     A      * Save for later
       A=B     A
       GOSUBL  nuDRAW

       GOSUBL  srR0
       A=C     A
       LCHEX   000AA
       C=C+D   A
       C=C+A   A
       D0=C
       LCHEX   4
       DAT0=C  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       DAT0=C  1

       C=0     A
       GOSUBL  srS8   * # of whites
       GOSUBL  srR1   * level
cgWAGN GOSUBL  srS7   * counter
       GOSUBL  srR1
cgWD1  ASL     W
       A=R1.F  P      * P==0
       C=C-1   A
       GONC    cgWD1
       LCHEX   EEEEEE
       B=C     W
       D=0     A
       GOSUBL  srR1
       P=C     0
       C=R2

cgWHT  ?C#A    P
       GOYES   cgWNXT
       D=D+1   A
       C=B     P
       R2=C
       GOTO    cgWDNE
cgWNXT P=P-1
       GONC    cgWHT
cgWDNE P=      0
       A=R1
       ASR     W      * move to next slot
       R1=A

       GOSUBL  srR8
       C=C+D   A
       GOSUBL  srS8
       GOSUBL  srR7
       C=C-1   A
       GOC     cgWOVR
       GOTO    cgWAGN

cgWOVR GOSUBL  srR6   * cursor offset
       LAHEX   000EE
cgND2  C=C-A   A
       GONC    cgND2
       C=C+A   A
       LAHEX   006C7  * offset to 2nd #
       A=A+C   A
       GOSUBL  srR8
       CAEX    A
       GOSUBL  nuDRAW

       C=R4
       A=R3
       ?C#A    W      * check if you won
       GOYES   cgCONT
*****
*  YOU WIN!!!!!
*****
       ST=1    0      * set YOU WIN flag
       RTN            * done with kyGUES

cgCONT GOSUBL  srR2
       C=C+1   A
       GOSUBL  srS2
       A=C     A
       GOSUBL  srR4   * max guesses
       ?A=C    A
       RTNYES         * RTN from kyGUES
       GOSUBL  scPSUB * decr. the pot
       GOTO    kyGUES

* piPICK picks a puzzle
* based on which level.

piPICK GOSUBL  srR1   * Level
       B=C     A
       C=0     W
piNEXT D1=(5)  =TIMER2
       A=DAT1  8
piD1   A=A-1   P
       GONC    piD1
       D1=(5)  CRC
       A=0     A
       A=DAT1  1      * (0-F)
       ASRB.F  A      * (0-7)
       CSL     W
       C=C!A   A      * Add new shape
       B=B-1   A
       GONC    piNEXT
       R3=C           * Perm puzzle

       GOSUBL  srR0
       LAHEX   00019
       C=C+A   A
       D0=C

       LAHEX   3F
       GOSUBL  srR1
       B=C     A
piBOX  LCHEX   00005
piLINE DAT0=A  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    piLINE
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    piBOX

       RTN
* Done with piPICK


shDPUZ GOSUBL  srR1   * level
       D=C     A
       LCHEX   00019
       R1=C.F  A
       A=R3           * Puzzle
       R2=A
shDPLP C=R1.F  A
       A=0     A
       A=R2.F  P      * P==0
       GOSUBL  shDRAW
       A=R1.F  A
       LCHEX   000EE
       A=A+C   A
       R1=A.F  A
       A=R2
       ASR     W
       R2=A
       D=D-1   A
       GONC    shDPLP
       RTN

* Draw a shape anywhere
* on screen, at a nibble
* boundary. 
* C: nibble offset,
* A: shape number (0-7)
*
* KILLS A,B,C,D0,D1

shDRAW B=C     A
       GOSUBL  srR0  
       C=C+B   A
       D0=C

       LCHEX   0000C
       GOSBVL  =MUL#  * res in B

       C=PC
       GOTO    shNEXT

       NIBHEX  C0E13333E1C0
       NIBHEX  C0C0F3F3C0C0
       NIBHEX  E133D2D233E1
       NIBHEX  3333C0C03333
       NIBHEX  D2D23333D2D2
       NIBHEX  A251A251A251
       NIBHEX  1233F3F33312
       NIBHEX  F102A2A202F1
       NIBHEX  000000000000

shNEXT C=C+CON A,4    * C contains shapes addr
       C=C+B   A      * C is correct shape# addr
       D1=C

       LCHEX   00005  * 5+1 lines

shLINE A=DAT1  2
       DAT0=A  2
       D1=D1+  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    shLINE

       RTN

* Draw a number anywhere
* on screen, at a nibble
* boundary. 
* C: nibble offset,
* A: number (0-9)
*
* KILLS A,B,C,D0,D1

nuDRAW B=C     A
       GOSUBL  srR0  
       C=C+B   A
       D0=C

       LCHEX   00008
       GOSBVL  =MUL#  * res in B

       C=PC
       GOTO    nuNEXT

       NIBHEX  E11212E1 * 0
       NIBHEX  0011F310 * 1
       NIBHEX  31525291 * 2
       NIBHEX  22129263 * 3
       NIBHEX  C34040F3 * 4
       NIBHEX  A3929262 * 5
       NIBHEX  E1929262 * 6
       NIBHEX  02728203 * 7
       NIBHEX  61929261 * 8
       NIBHEX  915252E1 * 9

nuNEXT C=C+CON A,4    * C contains num addr
       C=C+B   A      * C is correct num addr
       D1=C

       LCHEX   00003  * 3+1 lines

nuLINE A=DAT1  2
       DAT0=A  2
       D1=D1+  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    nuLINE

       RTN


srR0   LCHEX   00000
       GOTO    srRC
srR1   LCHEX   00001
       GOTO    srRC
srR2   LCHEX   00002
       GOTO    srRC
srR3   LCHEX   00003
       GOTO    srRC
srR4   LCHEX   00004
       GOTO    srRC
srR5   LCHEX   00005
       GOTO    srRC
srR6   LCHEX   00006
       GOTO    srRC
srR7   LCHEX   00007
       GOTO    srRC
srR8   LCHEX   00008
       GOTO    srRC
srR9   LCHEX   00009
       GOTO    srRC
srR10  LCHEX   0000A
       GOTO    srRC
srR11  LCHEX   0000B
       GOTO    srRC
srR12  LCHEX   0000C
       GOTO    srRC
srR13  LCHEX   0000D
       GOTO    srRC
srR14  LCHEX   0000E
       GOTO    srRC
srR15  LCHEX   0000F
       GOTO    srRC
srR16  LCHEX   00010
       GOTO    srRC
srR17  LCHEX   00011
       GOTO    srRC
srR18  LCHEX   00012
       GOTO    srRC
srR19  LCHEX   00013
       GOTO    srRC
srR20  LCHEX   00014
       GOTO    srRC
srR21  LCHEX   00015

srRC   ACEX    A
       CD0EX
       RSTK=C
       C=A     A
       C=C+C   A
       C=C+C   A
       C=C+A   A
       A=R0.F  A
       A=A+C   A
       AD0EX
       C=DAT0  A
       CD0EX
       C=RSTK
       CD0EX
       RTN

srS0   GOSBVL  =CSLW5
       LCHEX   00000
       GOTO    srSC
srS1   GOSBVL  =CSLW5
       LCHEX   00001
       GOTO    srSC
srS2   GOSBVL  =CSLW5
       LCHEX   00002
       GOTO    srSC
srS3   GOSBVL  =CSLW5
       LCHEX   00003
       GOTO    srSC
srS4   GOSBVL  =CSLW5
       LCHEX   00004
       GOTO    srSC
srS5   GOSBVL  =CSLW5
       LCHEX   00005
       GOTO    srSC
srS6   GOSBVL  =CSLW5
       LCHEX   00006
       GOTO    srSC
srS7   GOSBVL  =CSLW5
       LCHEX   00007
       GOTO    srSC
srS8   GOSBVL  =CSLW5
       LCHEX   00008
       GOTO    srSC
srS9   GOSBVL  =CSLW5
       LCHEX   00009
       GOTO    srSC
srS10  GOSBVL  =CSLW5
       LCHEX   0000A
       GOTO    srSC
srS11  GOSBVL  =CSLW5
       LCHEX   0000B
       GOTO    srSC
srS12  GOSBVL  =CSLW5
       LCHEX   0000C
       GOTO    srSC
srS13  GOSBVL  =CSLW5
       LCHEX   0000D
       GOTO    srSC
srS14  GOSBVL  =CSLW5
       LCHEX   0000E
       GOTO    srSC
srS15  GOSBVL  =CSLW5
       LCHEX   0000F
       GOTO    srSC
srS16  GOSBVL  =CSLW5
       LCHEX   00010
       GOTO    srSC
srS17  GOSBVL  =CSLW5
       LCHEX   00011
       GOTO    srSC
srS18  GOSBVL  =CSLW5
       LCHEX   00012
       GOTO    srSC
srS19  GOSBVL  =CSLW5
       LCHEX   00013
       GOTO    srSC
srS20  GOSBVL  =CSLW5
       LCHEX   00014
       GOTO    srSC
srS21  GOSBVL  =CSLW5
       LCHEX   00015

srSC   GOSBVL  =ASLW5
       AD0EX
       GOSBVL  =ASLW5
       A=C     A
       C=C+C   A
       C=C+C   A
       C=C+A   A
       A=R0.F  A
       A=A+C   A
       D0=A
       GOSBVL  =CSRW5
       DAT0=C  A
       GOSBVL  =ASRW5
       D0=A
       GOSBVL  =ASRW5
       RTN

* ADD pot to score,
* display score.

scADD  GOSUBL  srR10
       B=0     W
       B=C     A
       GOSUBL  BSLW5
       GOSUBL  srR11
       B=C     A
       C=0     W
       GOSUBL  srR12
       SETDEC
       B=B+C   W
       SETHEX
       C=B     A
       GOSUBL  srS11
       GOSUBL  BSRW5
       C=B     A
       GOSUBL  srS10

* scDISP will disp the
* score without adding

scDISP GOSUBL  srR10
       A=0     W
       A=C     A
       GOSBVL  =ASLW5
       GOSUBL  srR11
       A=C     A
       LCHEX   00006
       B=C     A
       C=0     W
scDREV CSL     W
       C=A     P      * P==0
       ASR     W
       B=B-1   A
       GONC    scDREV

       R1=C
       LCHEX   00006
       D=C     A
       LCHEX   003BA
       R2=C.F  A

scNUMS A=0     A
scLEAD A=R1.F  P
       ?A#0    A
       GOYES   scDOIT
       A=R1
       ASR     W
       R1=A
       D=D-1   A
       GONC    scNUMS
       D=0     A

scDOIT A=0     A
       A=R1.F  P      * P==0
       C=R2.F  A
       GOSUBL  nuDRAW

       C=R2.F  A
       LAHEX   000AA
       C=C+A   A
       R2=C.F  A
       A=R1
       ASR     W
       R1=A

       D=D-1   A
       GONC    scDOIT
       RTN


* POT subtracter

scPSUB GOSUBL  srR12
       A=C     A
       GOSUBL  srR13
       SETDEC
       C=A-C   A
       SETHEX
       GOC     scOVER
       LAHEX   00500
       ?C>=A   A
       GOYES   scPSTO
scOVER LCHEX   00500
scPSTO GOSUBL  srS12

scDPOT GOSUB   srR0
       LAHEX   003B8  * offset to POT
       C=C+A   A
       D0=C
       LCHEX   00017
       A=0     A
scDPBL DAT0=A  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    scDPBL

       GOSUBL  srR12
       A=C     A
       LCHEX   00004
       B=C     A
       C=0     W
scPREV CSL     A
       C=A     P
       ASR     A
       B=B-1   A
       GONC    scPREV

       R1=C
       LCHEX   00004
       D=C     A
       LCHEX   003B8
       R2=C.F  A
       GOTO    scNUMS

* anNEWLEVEL
* bar moves up and down
* to erase guesses.

anNEWL LCHEX   00018
       B=C     A
       GOSUBL  srR4
       C=C+C   A
       B=B-C   A
       C=B     A
       R1=C.F  A      * offset
       LCHEX   0006C
       R2=C.F  A      * starting pitch

anNEXT LCHEX   00001
       D=C     A
       LAHEX   03
anNLR  C=R1.F  A      * current offset
       B=C     A
       GOSUBL  srR0
       C=C+B   A
       D0=C

       LCHEX   00036  * 54+1 dots
       B=C     A
anNLDN C=DAT0  2
       A=-A-1  A
       C=C&A   A
       A=-A-1  A
       A=A+A   A
       A=A+A   A
       C=C!A   A
       DAT0=C  2
       ASRB.F  A
       ASRB.F  A
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    anNLDN
       A=A+A   A
       A=A+A   A

       ?ST=1   11
       GOYES   anNSND
       GOSUBL  anTONE
       C=R2.F  A
       C=C-1   A
       R2=C.F  A

anNSND D=D-1   A
       GOC     anCONT
       GOTO    anNLR
anCONT A=R1.F  A
       A=A+1   A
       R1=A.F  A
       LCHEX   0001A
       ?A=C    A
       GOYES   anNRND
       GOTO    anNEXT

anNRND GOSUBL  srR9
       C=C-1   A
       GONC    anNRST
       GOTO    anNXTL
anNRST GOSUBL  srS9
       GOSUBL  srR1
       LAHEX   00004
       ?C<A    A
       GOYES   anMDEC
       ?ST=1   1
       GOYES   anMDEC
       ST=1    1
       GOTO    anBACK
anMDEC ST=0    1
       LAHEX   00005
       ?C#A    A
       GOYES   anMGET
       GOSUBL  srR4
       LAHEX   00007
       ?C>A    A
       GOYES   anMGET
       GOSUBL  srR5
       C=C-1   A
       GOSUBL  srS5
       ?C=0    A
       GOYES   anL6R
       GOTO    anBACK
anL6R  LCHEX   5
       GOSUBL  srS5

anMGET GOSUBL  srR4
       C=C-1   A
       GOSUBL  srS4
       GOTO    anBACK

anNXTL GOSUBL  srR1
       C=C+1   A
       GOSUBL  srS1
       GOSUBL  srS9
       LCHEX   A
       GOSUBL  srS4

       GOSUBL  srR1
       LAHEX   00002
       ?C>A    A
       GOYES   anDO4
       LCHEX   00200
       GOSUBL  srS13
       LCHEX   04000
       GOSUBL  srS14
       GOTO    anBACK

anDO4  A=A+1   A
       ?C>A    A
       GOYES   anDO5
       LCHEX   00500
       GOSUBL  srS13
       LCHEX   10000
       GOSUBL  srS14
       GOTO    anBACK

anDO5  A=A+1   A
       ?C>A    A
       GOYES   anDO6
       LCHEX   01000
       GOSUBL  srS13
       LCHEX   20000
       GOSUBL  srS14
       LCHEX   00007  * play L5 8 times
       GOSUBL  srS9
       GOTO    anBACK

anDO6  A=A+1   A
       ?C>A    A
       GOYES   anSTL6
       ST=1    4      * signal sound later
anSTL6 LCHEX   02500
       GOSUBL  srS13
       LCHEX   50000
       GOSUBL  srS14
       LCHEX   FF     * too many to count
       GOSUBL  srS9

anBACK LCHEX   00019
       R1=C.F  A
anBNXT LCHEX   00001
       D=C     A
       LAHEX   0C
anBLR  C=R1.F  A
       B=C     A
       GOSUBL  srR0
       C=C+B   A
       D0=C

       LCHEX   00036
anBLDN DAT0=A  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    anBLDN
       ASRB.F  A
       ASRB.F  A

       ?ST=1   11
       GOYES   anBNSD
       GOSUBL  anTONE
       C=R2.F  A
       C=C+1   A
       R2=C.F  A

anBNSD D=D-1   A
       GOC     anBCNT
       GOTO    anBLR

anBCNT A=R1.F  A
       A=A-1   A
       R1=A.F  A
       LCHEX   00017
       B=C     A
       GOSUBL  srR4
       C=C+C   A
       B=B-C   A
       ?A=B    A
       GOYES   anFIX
       GOTO    anBNXT

anFIX  GOSUBL  srR0
       C=C+A   A
       C=C+1   A
       D0=C
       LAHEX   1
       LCHEX   00036
anFDN  DAT0=A  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    anFDN

       ?ST=0   4
       RTNYES
       GOLONG  s3SND  * AUTO RTN

anTONE LCHEX   00003  * length
       B=C     A
anTAGN LCHEX   800
       OUT=C
       C=R2.F  A
anTD1  C=C-1   A
       GONC    anTD1
       C=0     A
       OUT=C
       C=R2.F  A
anTD2  C=C-1   A
       GONC    anTD2
       B=B-1   A
       GONC    anTAGN
       RTN

* isINIT will draw the screen.

isINIT C=PC
       GOTO    isNEXT

       NIBHEX  9F33E39023149023F71F1336
       NIBHEX  1003361F1F36902E16902000
       NIBHEX  1F1FF71001041F3FF7900030
       NIBHEX  9000301F3FF7100FF71F1000
       NIBHEX  902FF3942104171FF7100036
**********
*

*
* Secret hiding place
*

       ST=1    3
       GOSUBL  chSECR
       ST=0    3
       GOSUBL  srR21
       D0=C
       LCHEX   00132  * #133h total
seNOT  A=DAT0  1
       A=-A-1  B
       DAT0=A  1
       D0=D0+  1
       C=C-1   A
       GONC    seNOT
       RTN

* #31h total nibbles
*
**********
       NIBHEX  100036100FF71F1FF3902000
       NIBHEX  902FF7111104100FF79F1036
       NIBHEX  1420361420F79F10E3100000
       NIBHEX  9F3FF7180104140FF79F3336
       NIBHEX  1003369F3306180306140000
       NIBHEX  9F33E31003141F13F7902336
       NIBHEX  9023361F1F36100E169F3000
       NIBHEX  1806C31409249F36C3

isNEXT C=C+CON A,4
       D1=C
       LAHEX   00078
       C=C+A   A
       RSTK=C

       GOSUBL  srR0
       LAHEX   0001B  * offset to right side
       C=C+A   A
       D0=C

       LCHEX   00013  * 19+1 Lines
isLIN1 A=DAT1  6
       DAT0=A  6
       D1=D1+  6
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    isLIN1

       AD1EX
       LCHEX   00031
       A=A+C   A
       D1=A
       LCHEX   0001E  * 30+1 Lines
isLIN2 A=DAT1  6
       DAT0=A  6
       D1=D1+  6
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    isLIN2

       C=0     A
       LCHEX   3      * 3+1 more lines
       B=C     A
       LCHEX   1      * the data
isDOTS DAT0=C  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    isDOTS

       C=PC
       GOTO    isNEX2

       NIBHEX  0011009200920062
       NIBHEX  000000E100120012
       NIBHEX  0021000000E1F312
       NIBHEX  421242E1810000F3
       NIBHEX  E142124212B1E100
       NIBHEX  00F30292F3920212
       NIBHEX  00002121

isNEX2 C=C+CON A,4
       D1=C

       GOSUBL  srR0
       D0=C

       LCHEX   00019  * 25+1 Lines
isLIN3 A=DAT1  4
       DAT0=A  4
       D1=D1+  4
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    isLIN3

       GOSUBL   srR0
       D0=C
       D0=D0+  4
       LCHEX   1
       LAHEX   00036  * 54+1 lines
isLIN4 DAT0=C  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       A=A-1   A
       GONC    isLIN4

       RTN

* Clear the message area

bnCLR  GOSUBL  srR0
       LAHEX   007B8
       C=C+A   A
       D0=C

       LCHEX   00005
       A=0     W
bnCLOP DAT0=A  W
       D0=D0+  16
       DAT0=A  7
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    bnCLOP
       RTN

bnPKEY GOSUB   bnCLR
       C=PC
       GOTO    bnPNXT

       NIBHEX  C837E9370C084F226
       NIBHEX  48492480021841224
       NIBHEX  4837E8130E1837414
       NIBHEX  48092024021841804
       NIBHEX  48092024021841804
       NIBHEX  C809ED9302184F806

bnPNXT C=C+CON A,4
       D1=C
       GOSUBL  srR0
       LAHEX   007BC
       C=C+A   A
       D0=C
       LCHEX   00005
bnPLIN A=DAT1  W
       DAT0=A  W
       D1=D1+  16
       D0=D0+  16
       A=DAT1  1
       DAT0=A  1
       D1=D1+  1
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    bnPLIN
       RTN


bnQUIT GOSUB   bnCLR
       C=PC
       GOTO    bnQNXT

       NIBHEX  E93DDF130A4825
       NIBHEX  5A251584094429
       NIBHEX  5A251504015469
       NIBHEX  5A2515020122A9
       NIBHEX  59251500012229
       NIBHEX  E2FC1702022125

bnQNXT C=C+CON A,4
       D1=C
       GOSUBL  srR0
       LAHEX   007BD
       C=C+A   A
       D0=C
       LCHEX   00005
bnQLIN A=DAT1  14
       DAT0=A  14
       D1=D1+  14
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    bnQLIN
       RTN

bnEXIT GOSUBL  bnCLR
       C=PC
       GOTO    bnENXT

       NIBHEX  F31DDF130A4825
       NIBHEX  58A41584094429
       NIBHEX  D1541504015469
       NIBHEX  50A415020122A9
       NIBHEX  50551500012229
       NIBHEX  FB8C1702022125

bnENXT C=C+CON A,4
       D1=C
       GOSUBL  srR0
       LAHEX   007BD
       C=C+A   A
       D0=C
       LCHEX   00005
bnELIN A=DAT1  14
       DAT0=A  14
       D1=D1+  14
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    bnELIN
       RTN

bnHOT  GOSUB   bnCLR
       C=PC
       GOTO    bnHNXT

       NIBHEX  737660BBBBAB23CD1EAEE
       NIBHEX  5511188A09A8A08414AA2
       NIBHEX  7372209A39931184144EE
       NIBHEX  151440AA09A0128414422
       NIBHEX  1573389B09A3918C1442E

bnHNXT C=C+CON A,4
       D1=C
       GOSUBL  srR0
       LAHEX   007DC
       C=C+A   A
       D0=C
       LCHEX   00004
bnHLIN A=DAT1  W
       DAT0=A  W
       D1=D1+  16
       D0=D0+  16
       A=DAT1  5
       DAT0=A  5
       D1=D1+  5
       D0=D0+  16
       D0=D0+  2
       C=C-1   A
       GONC    bnHLIN
       RTN


tbIN1  LCHEX   00013  * 10 seconds
       GOSUBL  srS16
tbIN2  D1=(5)  =TIMER2
       C=0     A
       C=DAT1  4
       GOSUBL  srS15
       RTN

tbTIME D1=(5)  =TIMER2
       A=0     A
       A=DAT1  4
       GOSUBL  srR15  * starting time
       C=C-A   A      * elapsed time
       GONC    tbOK
       LAHEX   FE000
       C=C-A   A

tbOK   LAHEX   01000
       ?A>=C   A      * not done?
       RTNYES

       GOSUBL  srR16
       C=C-1   A
       GOC     tbPOT
       GOSUBL  srS16
       GOTO    tbIN2

tbPOT  GOSUBL  srR12
       A=C     A
       GOSUBL  srR13
       CSR     A
       SETDEC
       C=C+C   A
       C=A-C   A
       SETHEX
       GOC     tbOVER
       LAHEX   00500
       ?C>=A   A
       GOYES   tbPSTO
tbOVER LCHEX   00500
tbPSTO GOSUBL  srS12
       GOSUBL  scDPOT
       GOSUBL  srR20
       C=C+1   A      * one more unit of 10 sec.
       GOSUBL  srS20
       GOTO    tbIN1

chHIGH GOSUBL  srR10
       B=0     W
       B=C     A
       GOSUBL  BSLW5
       GOSUBL  srR11
       B=C     A

       LCHEX   00006
       GOSUB   chGETS
       ?C>=B   W
       RTNYES

* You have a new high
* if you get here!

       LCHEX   00005
       D=C     A
chFIND GOSUBL  chGETS
       ?C>=B   W
       GOYES   chSPOT
       D=D-1   A
       GOC     chSPOT
       C=D     A
       GOTO    chFIND

chSPOT D=D+1   A
       C=B     W
       R1=C

       GOSUBL  srR17
       LAHEX   0012C  * ofset to S5
       C=C+A   A
       D1=C
       LAHEX   03C
       C=C+A   A
       D0=C

       LCHEX   0006C
       B=C     A
       LCHEX   00006
chMOVE ?C=D    A
       GOYES   chSSTO
       A=DAT1  W
       DAT0=A  W
       D1=D1+  16
       D0=D0+  16
       A=DAT1  W
       DAT0=A  W
       D1=D1+  16
       D0=D0+  16
       A=DAT1  W
       DAT0=A  W
       D1=D1+  16
       D0=D0+  16
       A=DAT1  12
       DAT0=A  12

       AD0EX
       A=A-B   A
       D0=A
       AD1EX
       A=A-B   A
       D1=A
       C=C-1   A
       GOTO    chMOVE

chSSTO LCHEX   0000E
       LAHEX   20
chBLNK DAT0=A  2
       D0=D0+  2
       C=C-1   A
       GONC    chBLNK
       D0=D0+  12

       LAHEX   30
       C=R1
       B=C     W
       LCHEX   00006

chWNUM A=B     P      * P==0
       DAT0=A  2
       D0=D0-  2
       BSR     W
       C=C-1   A
       GONC    chWNUM
       GOTO    chSAVE

* set C to score #(0-6) 
* & chGETS returns score
* into C.
* kills A, C, D1, R1

chGETS A=0     A
chCDEC C=C-1   A
       GOC     chGOK
       A=A+CON A,16
       A=A+CON A,16
       A=A+CON A,16
       A=A+CON A,12
       GOTO    chCDEC

chGOK  A=A+CON A,16
       A=A+CON A,14
       GOSUBL  srR17
       C=C+A   A
       D1=C
       LCHEX   00006
       R1=C.F  A
       C=0     W

chDIG  CSL     W
       A=DAT1  1
       C=A     P      * P==0
       D1=D1+  2
       A=R1.F  A
       A=A-1   A
       GOC     chGOTS
       R1=A.F  A
       GOTO    chDIG
chGOTS RTN

chSAVE AD0EX
       LCHEX   0001C
       C=A-C   A      * point to 1st let
       GOSUBL  srS7
       GOSUBL  srS8   * used for checksum

       C=0     A
       GOSUBL  srS9
       LCHEX   1
       GOSUBL  srS1
       GOSUBL  anNEWL

chSECR C=PC
       GOTO    chNEXT

       NIBHEX  0000000000DF10
       NIBHEX  0000000000DF10
       NIBHEX  00000000001C00
       NIBHEX  00000000001600
       NIBHEX  0000000000DF1E
       NIBHEX  0000000000DFD1
       NIBHEX  0000000000100E
       NIBHEX  00000000C7DF10
       NIBHEX  D130F10045DF97
       NIBHEX  5110410044DA58
       NIBHEX  71F1F10000DA58
       NIBHEX  00000000C3DA97
       NIBHEX  01F1F100011000
       NIBHEX  F1405100879F9F
       NIBHEX  01B1A00000DF50
       NIBHEX  0000000004D040

* This is the secret
* code to do the 
* checksums on the
* high scores
*
* #133h total nibbles

seCHK  GOSUBL  srR8
       LAHEX   0002C
       C=C+A   A
       D0=C

       GOSUBL  srR20
       LAHEX   3A5DB
       GOSUBL  AXORC

       D0=D0+  1
       DAT0=A  1      * t1
       ASR     A
       D0=D0+  9
       DAT0=A  1      * t2
       ASR     A
       D0=D0-  6
       DAT0=A  1      * t3
       ASR     A
       D0=D0+  10
       DAT0=A  1      * t4
       ASR     A
       D0=D0-  6
       DAT0=A  1      * t5

       D0=D0-  6      * point to g1
       GOSUBL  srR19
       DAT0=C  1      * g1
       CSR     A
       D0=D0+  11
       DAT0=C  1      * g2

       D0=D0-  12
       C=0     A
       C=DAT0  1
       R1=C.F  A      * save t1 here
       AD0EX
       D0=A
       LCHEX   0002D
       A=A-C   A
       D1=A

       A=0     A
       LCHEX   0002B
       D=C     A
seCHK1 C=0     A
       C=DAT1  1
       D1=D1+  1
       GOSUBL  AXORC
       GOSUBL  ASLBC
       C=R1.F  A
       GOSUBL  AXORC
       GOSUBL  ASLBC
       D=D-1   A
       GONC    seCHK1

       D0=D0+  11
       DAT0=A  1      * c1-1
       ASR     A
       D0=D0-  6
       DAT0=A  1      * c1-2

       AD1EX
       LCHEX   0002C
       A=A-C   A
       D1=A

       A=0     A
       LCHEX   00015
       D=C     A
seCHK2 C=0     A
       C=DAT1  2
       D1=D1+  2
       GOSUBL  AXORC
       GOSUBL  ASRBC
       D=D-1   A
       GONC    seCHK2

       D0=D0+  4
       C=0     A
       C=DAT0  1
       CSL     A
       C=DAT0  1      * C == t2t2
       GOSUBL  AXORC

       D0=D0-  1
       DAT0=A  1      * c2-1
       ASR     A
       D0=D0-  6
       DAT0=A  1      * c2-2
       GOLONG  BOGUS

       NIBHEX  F1F1F100C7978F
       NIBHEX  1010110004D000
       NIBHEX  F110110F00DF10
       NIBHEX  00000004C79F10
       NIBHEX  E1F1F10E551000
       NIBHEX  10C111004410CF
       NIBHEX  E1F1E00F101002
       NIBHEX  00000004D71002
       NIBHEX  F1F0F10F1510CF
       NIBHEX  70405100C6DF10
       NIBHEX  F1E1110F10DFD7
       NIBHEX  0000000C10120A
       NIBHEX  B1F1F10F10120A
       NIBHEX  4011410006DFD7
       NIBHEX  B1F1010FD1DF10
       NIBHEX  0000000516108F
       NIBHEX  81F1F10110DF50
       NIBHEX  70411100C7DF9F
       NIBHEX  81C17100441000
       NIBHEX  00000000C79FCF
       NIBHEX  31E1F10000DF5A
       NIBHEX  51214000C7D85A
       NIBHEX  91D1F10040DA58
       NIBHEX  00000000C7DB10
       NIBHEX  00F11100009B00
       NIBHEX  0041F100C71000
       NIBHEX  00B1110005DF10
       NIBHEX  00000000C6DFD7
       NIBHEX  0000000000120A
       NIBHEX  0000000000120A
       NIBHEX  0000000000DFD7
       NIBHEX  0000000000DF10
       NIBHEX  00000000001000
       NIBHEX  0000000000DE10
       NIBHEX  0000000000DE10

chNEXT C=C+CON A,4
       D1=C
       LAHEX   000E0
       C=C+A   A
       GOSUBL  srS21

       ?ST=1   3
       RTNYES

       GOSUBL  srR0
       LAHEX   00070
       C=C+A   A
       D0=C

       LCHEX   0000F
chMES1 A=DAT1  14
       DAT0=A  14
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       D1=D1+  14
       C=C-1   A
       GONC    chMES1

       AD1EX
       LCHEX   00133
       A=A+C   A
       D1=A
       LCHEX   00022
chMES2 A=DAT1  14
       DAT0=A  14
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       D1=D1+  14
       C=C-1   A
       GONC    chMES2

       GOSUBL  srR0
       LAHEX   00029
       C=C+A   A
       D0=C
       LCHEX   0000D
       D=C     A
chDOT1 LCHEX   2
       B=C     A
       LCHEX   4
chDOT2 DAT0=C  1
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       B=B-1   A
       GONC    chDOT2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       D=D-1   A
       GONC    chDOT1

       GOSUBL  bnHOT
       LCHEX   0002A
       GOSUBL  srS18
       A=0     A
       R2=A.F  A
       LAHEX   161
       R1=A.F  A
       GOSUB   inCTOG

inSTOP LCHEX   1D0
       OUT=C
       GOSBVL  =CINRTN
       LAHEX   0001F
       A=A&C   A
       ?A#0    A
       GOYES   inSTOP

inKEYS LCHEX   400
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 15
       GOYES   inCK
       GOLONG  maEND

inCK   LCHEX   080
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   inCQ
       GOTO    inCUP

inCQ   LCHEX   040
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 1
       GOYES   inCP
       GOTO    inCDWN

inCP   ?CBIT=0 2
       GOYES   inCR
       GOTO    inCLFT

inCR   ?CBIT=0 0
       GOYES   inCE
       GOTO    inCRGT

inCE   LCHEX   100
       OUT=C
       GOSBVL  =CINRTN
       LAHEX   0001F
       A=A&C   A
       ?A#0    A
       GOYES   inCDOE
       GOTO    inCBSP

inCDOE GOSUBL  srR18
       LAHEX   00712
       ?C>A    A
       GOYES   inENO
       A=R2.F  A
       ST=1    2      * set to draw mode
       GOSUBL  leDRAW
       GOSUBL  s4SND
       GOSUBL  srR18
       LAHEX   00088
       C=C+A   A
       GOSUBL  srS18
       GOSUBL  srR7
       D0=C
       A=R2.F  A
       LCHEX   0001A
       ?A#C    A
       GOYES   inEADD
       LCHEX   20
       GOTO    inESTO

inEADD LCHEX   41
       C=C+A   A
inESTO DAT0=C  2
       CD0EX
       C=C+CON A,2
       GOSUBL  srS7
       GOTO    inSTOP

inENO  GOSUBL  kyERRS
       GOTO    inSTOP

inCBSP LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=0 0
       GOYES   inCENT
       GOSUBL  srR18
       LAHEX   00088
       C=C-A   A
       GOC     inENO
       GOSUBL  srS18

       GOSUBL  srR7
       C=C-CON A,2
       GOSUBL  srS7
       D0=C
       LCHEX   20
       DAT0=C  2

       GOSUBL  srR18
       LAHEX   0001A
       ST=0    2      * set to erase mode
       GOSUBL  leDRAW * space
       GOSUBL  s4SND
       GOTO    inSTOP

inCENT LCHEX   010
       OUT=C
       GOSBVL  =CINRTN
       ?CBIT=1 4
       RTNYES
       GOTO    inKEYS

* R1 holds current curs
* offset on screen

inCTOG LCHEX   00004
       D=C     A
       A=R1.F  A
       GOSUBL  srR0
       C=C+A   A
       D0=C

       LCHEX   3F8
inCTDO A=DAT0  3
       A=-A-1  A
       A=A&C   A
       B=A     A
       A=DAT0  3
       C=-C-1  A
       A=A&C   A
       A=A!B   A
       C=-C-1  A
       DAT0=A  3
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       D=D-1   A
       GONC    inCTDO
       RTN

inCLFT GOSUB   inCTOG
inCLNT A=R1.F  A
       A=A-CON A,2
       R1=A.F  A
       A=R2.F  A
       A=A+CON A,9
       R2=A.F  A
       GOTO    inVERC

inCRGT GOSUB   inCTOG
inCRNT A=R1.F  A
       A=A+CON A,2
       R1=A.F  A
       A=R2.F  A
       A=A-CON A,9
       R2=A.F  A
       GOTO    inVERC

inCDWN GOSUB   inCTOG
       A=R1.F  A
       LCHEX   00088
       A=A+C   A
       R1=A.F  A
       A=R2.F  A
       A=A+1   A
       R2=A.F  A
       GOTO    inVERC

inCUP  GOSUB   inCTOG
       A=R1.F  A
       LCHEX   00088
       A=A-C   A
       R1=A.F  A
       A=R2.F  A
       A=A-1   A
       R2=A.F  A

inVERC A=R1.F  A
       LCHEX   0001B
       D=C     A
       LCHEX   22
       B=0     A
inVSUB A=A-C   A
       GOC     inVADD
       B=B+1   A
       GOTO    inVSUB
inVADD A=A+C   A
       LCHEX   00009
       ?A>=C   A
       GOYES   inVR
       C=R1.F  A
       C=C+CON A,6
       R1=C.F  A
       C=R2.F  A
       C=C-D   A
       R2=C.F  A

inVR   LCHEX   0000D
       ?A<=C   A
       GOYES   inVU
       C=R1.F  A
       C=C-CON A,6
       R1=C.F  A
       C=R2.F  A
       C=C+D   A
       R2=C.F  A

inVU   LCHEX   0000A
       ?B>=C   A
       GOYES   inVD
       A=R1.F  A
       LCHEX   004C8
       A=A+C   A
       R1=A.F  A
       C=R2.F  A
       C=C+CON A,9
       R2=C.F  A
       GOTO    inCRNT

inVD   LCHEX   0002A
       ?B<=C   A
       GOYES   inRET
       A=R1.F  A
       LCHEX   004C8
       A=A-C   A
       R1=A.F  A
       C=R2.F  A
       C=C-CON A,9
       R2=C.F  A
       GOTO    inCLNT

inRET  GOSUB   inCTOG
       GOTO    inSTOP

* Draw a letter anywhere
* on screen, at a nibble
* boundary. 
* C: nibble offset,
* A: letter (0-26)
*    26 is a space.
* KILLS A,B,C,D,D0,D1

leDRAW B=C     A
       GOSUBL  srR0  
       C=C+B   A
       D0=C

       LCHEX   00006
       GOSBVL  =MUL#  * res in B

       C=PC
       GOTO    leNEXT

       NIBHEX  F141F1F151A0F11111
       NIBHEX  F111E0F15111F14101
       NIBHEX  F11171F140F111F111
       NIBHEX  3010F1F140B1F11010
       NIBHEX  F1C1F1F040E1F111F1
       NIBHEX  F141C1E121D1F141B1
       NIBHEX  D1517101F101F110F1
       NIBHEX  E110E1F170F1B140B1
       NIBHEX  817081315191000000

leNEXT C=C+CON A,4    * C contains let addr
       C=C+B   A      * C is correct let addr
       D1=C

       LCHEX   00002  * 2+1 lines
       D=C     A

leLINE A=DAT0  2
       B=A     A
       A=DAT1  2
       ?ST=1   2      * draw ?
       GOYES   leOR

       LCHEX   1F
       A=-A-1  A
       A=A&C   A
       A=-A-1  A
       A=A&B   A
       GOTO    leSTO

leOR   A=A!B   A
leSTO  DAT0=A  2
       D1=D1+  2
       D0=D0+  16
       D0=D0+  16
       D0=D0+  2
       D=D-1   A
       GONC    leLINE

       RTN

BOGUS  D1=(5)  =TIMER2
       A=DAT1  8
       D1=(5)  CRC
       A=DAT1  1      * (0-F)
       D0=D0-  3
       DAT0=A  1      * b1

       D1=(5)  =TIMER2
       A=DAT1  8
       D1=(5)  CRC
       A=DAT1  1
       D0=D0+  5
       DAT0=A  1      * b2

       D1=(5)  =TIMER2
       A=DAT1  8
       D1=(5)  CRC
       A=DAT1  1
       D0=D0+  2
       DAT0=A  1      * b3

       D1=(5)  =TIMER2
       A=DAT1  8
       D1=(5)  CRC
       A=DAT1  1
       D0=D0+  4
       DAT0=A  1      * b4

       D1=(5)  =TIMER2
       A=DAT1  8
       D1=(5)  CRC
       A=DAT1  1
       D0=D0+  4
       DAT0=A  1      * b5
       GOLONG  maEND

* This does an A=A XOR C,
* C is unchanged, B is used.

AXORC  B=A     A
       GOSBVL  =ASLW5
       A=B     A
       A=A&C   A
       ABEX    A
       A=-A-1  A
       C=-C-1  A
       A=A&C   A
       B=B!A   A
       B=-B-1  A
       GOSBVL  =ASRW5
       C=-C-1  A
       A=A!C   A
       A=A&B   A
       RTN

ASLBC  A=A+A   B
       RTNNC
       A=A+1   B
       RTN

ASRBC  SB=0
       ASRB.F  B
       ?SB=0
       RTNYES
       ABIT=1  7
       RTN

BSLW5  BSL     W
       BSL     W
       BSL     W
       BSL     W
       BSL     W
       RTN

BSRW5  BSR     W
       BSR     W
       BSR     W
       BSR     W
       BSR     W
       RTN

*
* Some misc sounds
*

s1SND  ?ST=1   11
       RTNYES

       LAHEX   00050
s1AGN  LCHEX   800
       OUT=C
       C=A     A
s1D1   C=C-1   A
       GONC    s1D1
       C=0     A
       OUT=C
       C=A     A
s1D2   C=C-1   A
       GONC    s1D2
       A=A-1   A
       ?A#0    A
       GOYES   s1AGN

       LCHEX   02000
s1W1   C=C-1   A
       GONC    s1W1

       LCHEX   00005
       D=C     A

s1BLIP LCHEX   00500
s1W2   C=C-1   A
       GONC    s1W2

       LAHEX   00030
s1BLST LCHEX   800
       OUT=C
       LCHEX   00020
s1D3   C=C-1   A
       GONC    s1D3
       C=0     A
       OUT=C
       LCHEX   00020
s1D4   C=C-1   A
       GONC    s1D4
       A=A-1   A
       GONC    s1BLST
       D=D-1   A
       GONC    s1BLIP
       RTN

s2SND  ?ST=1   11
       RTNYES

       LAHEX   00050
s2AGN  LCHEX   800
       OUT=C
       C=A     A
s2D1   C=C-1   A
       GONC    s2D1
       C=0     A
       OUT=C
       C=A     A
s2D2   C=C-1   A
       GONC    s2D2
       A=A+1   A
       LCHEX   000D0
       ?A#C    A
       GOYES   s2AGN

       LCHEX   01000
s2W1   C=C-1   A
       GONC    s2W1

       LCHEX   00003
       D=C     A

s2BLIP LCHEX   00500
s2W2   C=C-1   A
       GONC    s2W2

       LAHEX   00008
s2BLST LCHEX   800
       OUT=C
       LCHEX   00100
s2D3   C=C-1   A
       GONC    s2D3
       C=0     A
       OUT=C
       LCHEX   00100
s2D4   C=C-1   A
       GONC    s2D4
       A=A-1   A
       GONC    s2BLST
       D=D-1   A
       GONC    s2BLIP
       RTN


s3SND  ?ST=1   11
       RTNYES

       LCHEX   00001
       D=C     A

s3BLIP LAHEX   00030
s3STRT LCHEX   800
       OUT=C
       LCHEX   00050
s3D1   C=C-1   A
       GONC    s3D1
       C=0     A
       OUT=C
       LCHEX   00050
s3D2   C=C-1   A
       GONC    s3D2
       A=A-1   A
       GONC    s3STRT
       LCHEX   04000
s3W1   C=C-1   A
       GONC    s3W1
       D=D-1   A
       GONC    s3BLIP

       LAHEX   00050
s3NOTE LCHEX   00010
       B=C     A
       LCHEX   00100
s3W2   C=C-1   A
       GONC    s3W2
s3AGN  LCHEX   800
       OUT=C
       C=A     A
s3D3   C=C-1   A
       GONC    s3D3
       C=0     A
       OUT=C
       C=A     A
s3D4   C=C-1   A
       GONC    s3D4

       B=B-1   A
       GONC    s3AGN

       A=A-CON A,10
       GONC    s3NOTE


       LCHEX   00001
       D=C     A

s3BL2  LCHEX   02000
s3W3   C=C-1   A
       GONC    s3W3

       LAHEX   000A0
s3BL2S LCHEX   800
       OUT=C
       LCHEX   0000A
s3D5   C=C-1   A
       GONC    s3D5
       C=0     A
       OUT=C
       LCHEX   0000A
s3D6   C=C-1   A
       GONC    s3D6
       A=A-1   A
       GONC    s3BL2S
       D=D-1   A
       GONC    s3BL2
       RTN


s4SND  ?ST=1   11
       RTNYES

       LAHEX   00010
s4AGN  LCHEX   800
       OUT=C
       C=A     A
s4D1   C=C-1   A
       GONC    s4D1
       C=0     A
       OUT=C
       C=A     A
s4D2   C=C-1   A
       GONC    s4D2
       A=A-1   A
       GONC    s4AGN
       RTN
