// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var symm
DIR
  RUN                 @main program name, enter your # ph. system and hit return.
    \<<
DUP                   @these two dups make a total of three copies of your 3 phase system.
DUP
'TF' STO              @stores one copy of your 3 phase system in a variable named TF.
ob\->                 @breaks the system into 3 separate complex numbers.
'f' STO               @stores the C phase complex number in a variable named f.
'd' STO               @stores the B phase complex number in a variable named d.
'c' STO               @stores the A phase complex number in a variable named c.
-16 SF                @sets system flag that puts the 48 in the angle mode.
-19 SF                @sets system flag that puts the 48 in complex number mode.
(-.5,.866025403784)   @(1\<120) a value used to mult a number and rotate it
                      @120 degrees counter clockwise.
'a' STO               @stores (1\<120) in a variable named a.
(-.5,-.866025403784)  @same as above but for clockwise rotation.
'b' STO               @stores (1\<-120) in a variable named b.
c                     @recalls the variable c to the stack.
b                     @recalls the variable b to the stack.
d                     @recalls the variable d to the stack.
*                     @multiplies d times b.
+                     @adds (d * b) to c.
a                     @recalls the variable a to the stack.
f                     @recalls the variable f to the stack.
*                     @multiplies f times a.
+                     @adds (f * a) to ((d * b) + c).
3 /                   @divides ((f * a) + (d * b) + c) by 3.
'IA' STO              @stores the above total in a variable named IA.
a                     @recalls the variable a to the stack.
IA                    @recalls the variable IA to the stack.
*                     @multiplies IA times a.
'IB' STO              @stores above total in a variable named IB.
b                     @recalls the variable b to the stack.
IA                    @recalls the variable IA to the stack.
*                     @multiplies IA times b.
'IC' STO              @stores the above total in a variable named IC.
c                     @recalls the variable c to the stack.
a                     @recalls the variable a to the stack.
d                     @recalls the variable d to the stack.
*                     @multiplies d times a.
+                     @adds (d * a) to c.
b                     @recalls the variable b to the stack.
f                     @recalls the variable f to the stack.
*                     @multiplies f times b.
+                     @adds (f * b) to ((d * a) + c).
3 /                   @divides ((f * b) + (d * a) + c) by 3.
'NIA' STO             @stores the above total in a variable named NIA.
b                     @recalls the variable b to the stack.
NIA                   @recalls the variable NIA to the stack.
*                     @multiplies NIA times b.
'NIB' STO             @stores the above total in a variable named NIB.
a                     @recalls the variable a to the stack.
NIA                   @recalls the variable NIA to the stack.
*                     @multiplies NIA times a.
'NIC' STO             @stores the above total in a variable named NIC.
IA                    @recalls the variable IA to the stack.
IB                    @recalls the variable IB to the stack.
IC                    @recalls the variable IC to the stack.
\->ar                 @this is a local program kept in this directory that
                      @works the same as \->ARRY but has 3 as the argument.
                      @\->ar builds this [(IA,IA) (IB,IB) (IC,IC)]
NIA                   @recalls the variable NIA to the stack.
NIB                   @recalls the variable NIB to the stack.
NIC                   @recalls the variable NIC to the stack.
\->ar                 @\->ar builds this [(NIA,NIA) (NIB,NIB) (NIC,NIC)]
TF                    @recalls the variable TF to the stack.
ob\->                 @breaks the system into 3 separate complex numbers.
+                     @adds two of the complex components together.
+                     @adds the third to this total.
3 /                   @puts a 3 on the stack then divides by total by 3.
DUP                   @makes two copies of the zero sequence value.
DUP                   @makes a third copy of the zero sequence value.
\->ar                 @builds an array like this [(zsa,zsa) (zsb,zsb) (zsc,zsc)].
{ IA IB IC NIA NIB NIC TF a b c d f PPAR }  @just a list of expendable vars.
PURGE                 @deletes the list of newly created variables.
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  ob\->               @a secondary program that is used in the main program.
    \<<
OBJ\->                @breaks a list into the separate items.
DROP                  @removes from the stack the number of parts in the list
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  \->ar               @a secondary program that is used in the main program.
    \<<
3                     @puts a 3 on the stack.
\->ARRY               @takes the 3 and makes a list of the 3 items on stacks 2 3 and 4
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  drp3                @a secondary program that is used in the main program.
    \<<
3                     @puts a 3 on the stack.
DROPN                 @removes 3 items from the stack.
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  help                @a secondary program that provides three help screens.
    \<<
help1                 @recalls a graphic object called "help1" to stack 1.
PICT                  @this is a reserved variable used for holding graphics.
STO                   @stores the stack 2 variable in the PICT variable.
{ } PVIEW             @this line will display the graphic stored in PICT.
help2                 @same as above but uses variable "help2".
PICT STO
{ } PVIEW
help3                 @same as above but uses variable "help3".
PICT STO
{ } PVIEW
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  info                @a secondary program that provides a graphic information screen
    \<<
SYMPICT               @recalls a graphic object called "sympict" to stack 1.
PICT                  @this is a reserved variable used for holding graphics.
STO                   @stores the stack 2 variable in the PICT variable.
{ } PVIEW             @this line will display the graphic stored in PICT
    \>>
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  help1               @a variable holding a graphic object of a help text screen.
GROB 131 64 00000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00065154773DD5AB47600007E81000000000015BD612555DA8521000051010000000000225557\
23D5DBB72200007D01000000000042154125545B8624000019010000000000321547255C5AB42\
300001EA3000000000000000000000000000000000007D8D10E2DDD0804944D1449E0EA230000\
015580026944141455450445204AA8000007D8800EE9CD0C14D54D1443E04E21000001519802A\
944141845450445204A2A0000015D840E29C514184DDD1C59E04AA10000000000000000000000\
0000000000000000030DC1AB086A82437710DC12819A0C000001884092144A82224428841109A\
21800000188C983144E831272288C9839A31800000188059214480A2241288451092218000003\
0DDDBB08E82A777110DDD3831A0C000000000000000000000000000000000000000730528BAC0\
EE6220000000000000000000550D209A202AA630000000000000000000530D309B40EA6A20000\
0000000000000005505309A802AA2200000000000000000007505209A602EA220000000000000\
000000000000000000000000000000000000000030D417836E202811C07C504054106E2030188\
4150242401092205090205410484020188C17834E409392E07880277C1E444020188015A04840\
1092A4448020409042402030D1579BEE202839E27540404150E22030000000000000000000000\
00000000000001575066A46E0664C2DD91C5D95370770001525019AAA20AAA2A4840459445105\
10005527029AE6E066E26C9804598457057000B525045AAA20AAA2A4801459055105100015250\
3AEAAE06AAC2D9C0CD9C4370710000000000000000000000000000000000000753770671D5C51\
4AA86E6C00000000000025511015B55441CAADA2A2000000000000273770155D5C90CBAA6E640\
00000000000255110151544414BA8A2A80000000000002557706715CD514AB86EA62000000000\
0000000000000000000000000000000000009EAE0AEA0E6ECC0EAE06A21C4DDD520000B2A40AA\
A0AA22204A20AA6145984D20000FE4404AA0E6E4404EE06AE1C4984D30000D2A404AA02A28804\
A20AAA1459845300009EA404EE02AE6604AE0AE21CC98C5A00000000000000000000000000000\
000000000575309A2A9B188A800770770672690A00055550BA6BA8288A808050250125150A000\
25530FAAA9B18AA808650250227130E00025550DA2AA828DA8084502504251508000277509E2A\
9B288AB307702703256908200000000000000000000000000000000000000000DDC991C528BB1\
88E6E0AE2E200000000005554404D288A28DAA20A22A20000000000CDC9804D38BA18AA6E0EE2\
E0000000000044501145388A288AA20A2220000000000044DDC0C5288B288EAE0AEE200000000\
00000000000000000000000000000000
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  help2               @a variable holding a graphic object of a help text screen.
GROB 131 64 00000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00065154773DD5AB47600007E83000000000015BD612555DA8521000051020000000000225557\
23D5DBB72200007D83000000000042154125545B8624000019800000000000321547255C5AB42\
300001EA3000000000000000000000000000000000005753029C2AB188A808930000000000000\
0555505B22A8288A808A800000000000000255307F4AAB18AA8089300000000000000255505D8\
6B828DA808A800000000000000277505962AB288AB38930000000000000000000000000000000\
00000000000000000776D5570676AE29D1C520B31B40700000055194510119A265404D2809A82\
0400000075294570279AEE5C14D3019B810700000015494210415A2A540453029A82040000001\
739427037AEE29D1C528192B40700000000000000000000000000000000000000009EC9C55706\
76AE29D1C520B31B40700000B22494510119A265404D2809A820400000FEAD94570279AEE5C14\
D3019B810700000D22594210415A2A540453029A8201000009EC59427037AEE29D1C528192B40\
70000000000000000000000000000000000000002960EE6E0CEC4D52B38B406726906000005BA\
082AA022255CA808A501251504000007FA04E6A04E25DDB838A702271304000005DA022AA082A\
454B808A604251504000005960EEAE06E4DD52B38B40325690E00000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000073766075707320\
2D51CD18DD18440CD00055111025105540A4418414440454045100737220277053F06C908418C\
D1C5404D00015144025105540A4808410540454045100157330257073202D908C1CCD14DD1C51\
0000000000000000000000000000000000001D9D1CD1C5D1C5DCD1C9CC91CD1C5D1000B558045\
084508455404559404508450000559804D18CD18CDCD1CDD8804D18CD10001519045084508455\
4044590145084500001DD80C5084D1845DD14459C0C5084D10000000000000000000000000000\
0000000006527170671DD529470790CE4C21C0000001DA011015B55DAA5205B024A2A08000000\
2DB6170155D5DBB7205F044E260800000045B4110151545BA6205D084A2A08000000352777067\
15C5AA42079064AC21C500000000000000000000000000000000000000000000DDC991C528BB1\
88E6E0AE2E200000000005554404D288A28DAA20A22A20000000000CDC9804D38BA18AA6E0EE2\
E0000000000044501145388A288AA20A2220000000000044DDC0C5288B288EAE0AEE200000000\
00000000000000000000000000000000
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  help3               @a variable holding a graphic object of a help text screen.
GROB 131 64 00000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00065154773DD5AB47600007E83000000000015BD612555DA8521000051020000000000225557\
23D5DBB72200007D83000000000042154125545B8624000019020000000000321547255C5AB42\
300001EA300000000000000000000000000000000000737660757024602D51CD1CCD451300000\
055111025104AA0A44184145455150000007372202770FE606C90841CCD451500000015144025\
104AA0A480841454551500000015733025702AA02D908C14DDC57300000000000000000000000\
00000000000000000757075110671DD5AB4705AB30B31B4030025101511015B55DA8520D29280\
9A820200277075110155D5DBB720D392019B810200251015110151545B86205392029A8202002\
570177706715C5AB42052938192B4070000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000007376607570337709EA0EE066EE00000000551\
11025105554052A04A0AAAA000000007372202770537703E404A0A6AE00000000151440251055\
14052404A0AAA2000000001573302570351709E404E06AE200000000000000000000000000000\
0000000000000753770DD5460777075703777711CD1000025511094C6105110251055225B1450\
00002737709C55205770277035225514D10000255110944440511025105522511450000025577\
09C5430711025703722711C500000000000000000000000000000000000000075706726900000\
00000000000000000000251012515000000000000000000000000027702271300000000000000\
00000000000251042515000000000000000000000000025703256920000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
00000000000000000000000000000000000000000000000000000000000000000000000000000\
000000000EEE602AC2184A1829A38BA4000000000001AAA02A2A04DA28AAA088A500000000000\
DAAA02A260CDB28BBA38BA7000000000009AAA02A2A045B28A29088A600000000000EEE60EEC2\
145A18A29388B4000000000000000000000000000000000000000000000000000000000000000\
72510129C4CEE6000000000000000000005551015B2A242A000000000000000000007751017F2\
E44E6000000000000000000001551015D2A842A0000000000000000000015770759CA64EA0000\
00000000000000000000000000000000
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  SYMPICT             @a variable holding a graphic object of a info text screen
GROB 131 64 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF705555100000000000000000000000455\
55055551C982A8EBFE17E172AF2AFC1455550555512A86BD2022222A86A062222455550555512\
88AAA2022222A86A06222045555055551205AAA2022222A8AA0A222045555055551C12AAAE12E\
12E98AA7A22C1455550555510222A8202A022882B023202455550555510222A82022122882B02\
3202455550555512222A82022222882A02222245555055551C122A8E322272072AF222C145555\
0555510000000000000000000000045555055551000000000000000000000004555505555100C\
10000070000E00000000455550555510422000098000011000C30045555055551321483894017\
0802100C400455550555594A08844A20290404100410045555055559762097CB904F02E810042\
00455550555594E10944A7049021E100840045555055559400083420007001000008004555505\
5551000000000000001000000104555505555900008004000100E000000204555505555130004\
00800800000000000045555055551C00020001040000000000004555505555103001000202000\
400000000455550555510C0800004010004000000004555505555100340C70880010400180402\
4555505555100C200000500104001018044555505555100010000020C7040C702018455550555\
5100800C70020010A001000004555505555100400000020010110100000455550555510020000\
00200080200000004555505555100000000020000000000000455550555510000000002000000\
000000045555055551007000000200030C1081E0E455550555510800000002008404204221145\
555055551080000000200870C30C3E11455550555510800000000008404204221145555055551\
007000000700840C1042E0E455550555510000000080000000000000045555055551000000008\
00000000000000455550555510000000080000000000000045555055551000000000700000000\
00000455550555510000000000000000000000045555055551000000000000000000000004555\
505555FFFFFFFFFFFFFFFFFFFFFFFF75555055555100000000000000000000045555505555510\
0C30003400000000400045555505555510044E44240EC3EC1FE83D4555550555D590044054240\
05410A044434D5555055514900C3E54240E541C374C314145550555F79B440154240154122844\
014F75550555009A44015424015412284501400555055DFF93740E977C7E54EC378831CFF5550\
551002020000000000000000000200455055FFF7010000000010000000000FFF7550550008000\
00000000000000000800005505DFFFF10088C96E81EC3C06000CFFFF550510000200882A11011\
54809000200004505FFFFF70088E90E01154804000FFFFF750500000800052800111548020080\
0000050DFFFFFF1002C90F83E44C5F00CFFFFFF501000000200000000000000000200000040FF\
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  TEST                @this variable holds an unbalanced 3 phase system.
[ (14.4888873943,3.88228567654) (-8.02956727631,8.91773790573) (-5.4723222932\
1,-15.0350819326) ]
END
